// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// A copy activity sink.
    /// </summary>
    public abstract partial class CopySink
    {
        private bool? _sinkPartitionData;
        
        /// <summary>
        /// Optional. Sink partition data.
        /// </summary>
        public bool? SinkPartitionData
        {
            get { return this._sinkPartitionData; }
            set { this._sinkPartitionData = value; }
        }
        
        private int? _sinkRetryCount;
        
        /// <summary>
        /// Optional. Sink retry count.
        /// </summary>
        public int? SinkRetryCount
        {
            get { return this._sinkRetryCount; }
            set { this._sinkRetryCount = value; }
        }
        
        private System.TimeSpan? _sinkRetryWait;
        
        /// <summary>
        /// Optional. Sink retry wait.
        /// </summary>
        public System.TimeSpan? SinkRetryWait
        {
            get { return this._sinkRetryWait; }
            set { this._sinkRetryWait = value; }
        }
        
        private int _writeBatchSize;
        
        /// <summary>
        /// Required. Write batch size.
        /// </summary>
        public int WriteBatchSize
        {
            get { return this._writeBatchSize; }
            set { this._writeBatchSize = value; }
        }
        
        private TimeSpan _writeBatchTimeout;
        
        /// <summary>
        /// Required. Write batch timeout.
        /// </summary>
        public TimeSpan WriteBatchTimeout
        {
            get { return this._writeBatchTimeout; }
            set { this._writeBatchTimeout = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CopySink class.
        /// </summary>
        public CopySink()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the CopySink class with required
        /// arguments.
        /// </summary>
        public CopySink(int writeBatchSize, TimeSpan writeBatchTimeout)
            : this()
        {
            this.WriteBatchSize = writeBatchSize;
            this.WriteBatchTimeout = writeBatchTimeout;
        }
    }
}
