// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Dns.Models
{
    /// <summary>
    /// An NS record.
    /// </summary>
    public partial class NsRecord
    {
        private string _nsdname;
        
        /// <summary>
        /// Required. Gets or sets the name server name for this record,
        /// without a terminating dot.
        /// </summary>
        public string Nsdname
        {
            get { return this._nsdname; }
            set { this._nsdname = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NsRecord class.
        /// </summary>
        public NsRecord()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the NsRecord class with required
        /// arguments.
        /// </summary>
        public NsRecord(string nsdname)
            : this()
        {
            if (nsdname == null)
            {
                throw new ArgumentNullException("nsdname");
            }
            this.Nsdname = nsdname;
        }
    }
}
