// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resources.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// </summary>
    public partial class ResourceManagementErrorWithDetails : ResourceManagementError
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ResourceManagementErrorWithDetails class.
        /// </summary>
        public ResourceManagementErrorWithDetails() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ResourceManagementErrorWithDetails class.
        /// </summary>
        public ResourceManagementErrorWithDetails(string code, string message, string target = default(string), IList<ResourceManagementError> details = default(IList<ResourceManagementError>))
            : base(code, message, target)
        {
            Details = details;
        }

        /// <summary>
        /// Gets or sets validation error.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public IList<ResourceManagementError> Details { get; set; }

        /// <summary>
        /// Validate the object. Throws ArgumentException or ArgumentNullException if validation fails.
        /// </summary>
        public override void Validate()
        {
            base.Validate();
            if (this.Details != null)
            {
                foreach (var element in this.Details)
                {
                    if (element != null)
                    {
                        element.Validate();
                    }
                }
            }
        }
    }
}
