// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Represents the properties of an Azure SQL Database Service Objective.
    /// </summary>
    public partial class ServiceObjectiveProperties
    {
        private string _description;
        
        /// <summary>
        /// Optional. Gets the description for the service level objective.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private bool _enabled;
        
        /// <summary>
        /// Optional. Gets whether the service level objective is enabled.
        /// </summary>
        public bool Enabled
        {
            get { return this._enabled; }
            set { this._enabled = value; }
        }
        
        private bool _isDefault;
        
        /// <summary>
        /// Optional. Gets whether the service level objective is the default
        /// service objective.
        /// </summary>
        public bool IsDefault
        {
            get { return this._isDefault; }
            set { this._isDefault = value; }
        }
        
        private bool _isSystem;
        
        /// <summary>
        /// Optional. Gets whether the service level objective is a system
        /// service objective.
        /// </summary>
        public bool IsSystem
        {
            get { return this._isSystem; }
            set { this._isSystem = value; }
        }
        
        private string _serviceObjectiveName;
        
        /// <summary>
        /// Optional. Gets the name for the service objective.
        /// </summary>
        public string ServiceObjectiveName
        {
            get { return this._serviceObjectiveName; }
            set { this._serviceObjectiveName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServiceObjectiveProperties class.
        /// </summary>
        public ServiceObjectiveProperties()
        {
        }
    }
}
