// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Automation.Models;

namespace Microsoft.WindowsAzure.Management.Automation.Models
{
    /// <summary>
    /// An automation resource item.
    /// </summary>
    public partial class AutomationResource
    {
        private string _eTag;
        
        /// <summary>
        /// Optional. Gets or sets the ETag for this resource.
        /// </summary>
        public string ETag
        {
            get { return this._eTag; }
            set { this._eTag = value; }
        }
        
        private SubscriptionIntrinsicSettings _intrinsicSettings;
        
        /// <summary>
        /// Optional. Gets or sets the intrinsic settings of resource.
        /// </summary>
        public SubscriptionIntrinsicSettings IntrinsicSettings
        {
            get { return this._intrinsicSettings; }
            set { this._intrinsicSettings = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the user-input name of this item.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _namespace;
        
        /// <summary>
        /// Optional. Gets or sets the namespace in which this item resides.
        /// </summary>
        public string Namespace
        {
            get { return this._namespace; }
            set { this._namespace = value; }
        }
        
        private string _plan;
        
        /// <summary>
        /// Optional. Gets or sets the plan for this item as selected by the
        /// user.
        /// </summary>
        public string Plan
        {
            get { return this._plan; }
            set { this._plan = value; }
        }
        
        private string _schemaVersion;
        
        /// <summary>
        /// Optional. Gets or sets the schema version for this resource.
        /// </summary>
        public string SchemaVersion
        {
            get { return this._schemaVersion; }
            set { this._schemaVersion = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Gets or sets the state of this resource.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. Gets or sets the type of the item.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AutomationResource class.
        /// </summary>
        public AutomationResource()
        {
        }
    }
}
