// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// Details required to create or set a template image.
    /// </summary>
    public partial class TemplateImageDetails
    {
        private string _id;
        
        /// <summary>
        /// Optional. The unique identifier for the image. This is only
        /// required to update an existing template image.  Leave this blank
        /// to create a new template image.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. The friendly name for the image.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _region;
        
        /// <summary>
        /// Required. The region where the image will be used. The region can
        /// not be changed once a template image has been created.  Leave this
        /// blank if you want to update an existing template image.
        /// </summary>
        public string Region
        {
            get { return this._region; }
            set { this._region = value; }
        }
        
        private int _sizeInGB;
        
        /// <summary>
        /// Optional. The size of this VHD.
        /// </summary>
        public int SizeInGB
        {
            get { return this._sizeInGB; }
            set { this._sizeInGB = value; }
        }
        
        private string _sourceImageSasUri;
        
        /// <summary>
        /// Optional. The URI with shared access signature (SAS) of the source
        /// image.If this parameter is specified the RemoteApp service will
        /// copy the specified image blob to its internal storage.
        /// </summary>
        public string SourceImageSasUri
        {
            get { return this._sourceImageSasUri; }
            set { this._sourceImageSasUri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the TemplateImageDetails class.
        /// </summary>
        public TemplateImageDetails()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the TemplateImageDetails class with
        /// required arguments.
        /// </summary>
        public TemplateImageDetails(string name, string region)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (region == null)
            {
                throw new ArgumentNullException("region");
            }
            this.Name = name;
            this.Region = region;
        }
    }
}
