// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Sql.Models;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Represents the event log entry for a database.
    /// </summary>
    public partial class DatabaseEventLog : SqlModelCommon
    {
        private string _additionalData;
        
        /// <summary>
        /// Optional. Gets any additional data for the event log.
        /// </summary>
        public string AdditionalData
        {
            get { return this._additionalData; }
            set { this._additionalData = value; }
        }
        
        private string _databaseName;
        
        /// <summary>
        /// Optional. Gets the name of the database pertaining to this log.
        /// </summary>
        public string DatabaseName
        {
            get { return this._databaseName; }
            set { this._databaseName = value; }
        }
        
        private string _description;
        
        /// <summary>
        /// Optional. Gets the description of the event log.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private string _eventCategory;
        
        /// <summary>
        /// Optional. Gets the event category of the event log.
        /// </summary>
        public string EventCategory
        {
            get { return this._eventCategory; }
            set { this._eventCategory = value; }
        }
        
        private string _eventSubtype;
        
        /// <summary>
        /// Optional. Gets the event sub type of the event log.
        /// </summary>
        public string EventSubtype
        {
            get { return this._eventSubtype; }
            set { this._eventSubtype = value; }
        }
        
        private string _eventSubtypeDescription;
        
        /// <summary>
        /// Optional. Gets the event sub type description of the event log.
        /// </summary>
        public string EventSubtypeDescription
        {
            get { return this._eventSubtypeDescription; }
            set { this._eventSubtypeDescription = value; }
        }
        
        private string _eventType;
        
        /// <summary>
        /// Optional. Gets the event type of the event log.
        /// </summary>
        public string EventType
        {
            get { return this._eventType; }
            set { this._eventType = value; }
        }
        
        private int _intervalSizeInMinutes;
        
        /// <summary>
        /// Optional. Gets the interval size of the event log expressed in
        /// minutes.
        /// </summary>
        public int IntervalSizeInMinutes
        {
            get { return this._intervalSizeInMinutes; }
            set { this._intervalSizeInMinutes = value; }
        }
        
        private int _numberOfEvents;
        
        /// <summary>
        /// Optional. Gets the number of events of the event log.
        /// </summary>
        public int NumberOfEvents
        {
            get { return this._numberOfEvents; }
            set { this._numberOfEvents = value; }
        }
        
        private int _severity;
        
        /// <summary>
        /// Optional. Gets the severity of the event log.
        /// </summary>
        public int Severity
        {
            get { return this._severity; }
            set { this._severity = value; }
        }
        
        private DateTime _startTimeUtc;
        
        /// <summary>
        /// Optional. Gets the start time of the event log.
        /// </summary>
        public DateTime StartTimeUtc
        {
            get { return this._startTimeUtc; }
            set { this._startTimeUtc = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseEventLog class.
        /// </summary>
        public DatabaseEventLog()
        {
        }
    }
}
