// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Information about the access control records which needs to be either
    /// added or delete or update
    /// </summary>
    public partial class AccessControlRecord
    {
        private string _globalId;
        
        /// <summary>
        /// Optional. Global Id
        /// </summary>
        public string GlobalId
        {
            get { return this._globalId; }
            set { this._globalId = value; }
        }
        
        private string _initiatorName;
        
        /// <summary>
        /// Required. Initiator name
        /// </summary>
        public string InitiatorName
        {
            get { return this._initiatorName; }
            set { this._initiatorName = value; }
        }
        
        private string _instanceId;
        
        /// <summary>
        /// Optional. The instance identifier
        /// </summary>
        public string InstanceId
        {
            get { return this._instanceId; }
            set { this._instanceId = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. The name of the entity
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private OperationInProgress _operationInProgress;
        
        /// <summary>
        /// Optional. State of operation in progress
        /// </summary>
        public OperationInProgress OperationInProgress
        {
            get { return this._operationInProgress; }
            set { this._operationInProgress = value; }
        }
        
        private int _volumeCount;
        
        /// <summary>
        /// Optional. Total volume count
        /// </summary>
        public int VolumeCount
        {
            get { return this._volumeCount; }
            set { this._volumeCount = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AccessControlRecord class.
        /// </summary>
        public AccessControlRecord()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the AccessControlRecord class with
        /// required arguments.
        /// </summary>
        public AccessControlRecord(string name, string initiatorName)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (initiatorName == null)
            {
                throw new ArgumentNullException("initiatorName");
            }
            this.Name = name;
            this.InitiatorName = initiatorName;
        }
    }
}
