// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class respresents the iSCSI chap settings.
    /// </summary>
    public partial class MigrationChapSetting
    {
        private string _id;
        
        /// <summary>
        /// Optional. Gets or sets the Id of the chap settings.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the chap setting
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Required. Gets or sets the chap password
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _secretsEncryptionThumbprint;
        
        /// <summary>
        /// Required. Gets or sets the password encryption thumbprint.
        /// </summary>
        public string SecretsEncryptionThumbprint
        {
            get { return this._secretsEncryptionThumbprint; }
            set { this._secretsEncryptionThumbprint = value; }
        }
        
        private bool _valid;
        
        /// <summary>
        /// Required. Gets or sets a value indicating whether the chap is valid
        /// or not.
        /// </summary>
        public bool Valid
        {
            get { return this._valid; }
            set { this._valid = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MigrationChapSetting class.
        /// </summary>
        public MigrationChapSetting()
        {
        }
    }
}
