// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class respresents confirmation status for a specific data
    /// container.
    /// </summary>
    public partial class MigrationContainerConfirmStatus
    {
        private string _cloudConfigurationName;
        
        /// <summary>
        /// Required. Gets or sets name of the data container
        /// </summary>
        public string CloudConfigurationName
        {
            get { return this._cloudConfigurationName; }
            set { this._cloudConfigurationName = value; }
        }
        
        private MigrationOperation _operation;
        
        /// <summary>
        /// Required. Gets or sets confirm migration operation which is being
        /// executed
        /// </summary>
        public MigrationOperation Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        private int _percentageCompleted;
        
        /// <summary>
        /// Required. Gets or sets the percentage of rollback/commit operation
        /// completed
        /// </summary>
        public int PercentageCompleted
        {
            get { return this._percentageCompleted; }
            set { this._percentageCompleted = value; }
        }
        
        private MigrationDataContainerConfirmStatus _status;
        
        /// <summary>
        /// Required. Gets or sets the confirmation status
        /// </summary>
        public MigrationDataContainerConfirmStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private IList<HcsMessageInfo> _statusMessage;
        
        /// <summary>
        /// Required. Gets or sets contains the volume container level message
        /// and recommendations
        /// </summary>
        public IList<HcsMessageInfo> StatusMessage
        {
            get { return this._statusMessage; }
            set { this._statusMessage = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MigrationContainerConfirmStatus
        /// class.
        /// </summary>
        public MigrationContainerConfirmStatus()
        {
            this.StatusMessage = new LazyList<HcsMessageInfo>();
        }
    }
}
