// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class represents request body of import data container.
    /// </summary>
    public partial class MigrationImportDataContainerRequest
    {
        private IList<string> _dataContainerNames;
        
        /// <summary>
        /// Required. Gets or sets list of volume container names to be migrated
        /// </summary>
        public IList<string> DataContainerNames
        {
            get { return this._dataContainerNames; }
            set { this._dataContainerNames = value; }
        }
        
        private bool _forceOnOtherDevice;
        
        /// <summary>
        /// Required. Gets or sets the value indicating whether to migrate the
        /// volume container by force
        /// </summary>
        public bool ForceOnOtherDevice
        {
            get { return this._forceOnOtherDevice; }
            set { this._forceOnOtherDevice = value; }
        }
        
        private bool _skipACRs;
        
        /// <summary>
        /// Required. Gets or sets a value indicating whether to skip the
        /// Access control records from migration
        /// </summary>
        public bool SkipACRs
        {
            get { return this._skipACRs; }
            set { this._skipACRs = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// MigrationImportDataContainerRequest class.
        /// </summary>
        public MigrationImportDataContainerRequest()
        {
            this.DataContainerNames = new List<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// MigrationImportDataContainerRequest class with required arguments.
        /// </summary>
        public MigrationImportDataContainerRequest(List<string> dataContainerNames, bool forceOnOtherDevice, bool skipACRs)
            : this()
        {
            if (dataContainerNames == null)
            {
                throw new ArgumentNullException("dataContainerNames");
            }
            this.DataContainerNames = dataContainerNames;
            this.ForceOnOtherDevice = forceOnOtherDevice;
            this.SkipACRs = skipACRs;
        }
    }
}
