// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Migration Operation represents various confirm operation that is
    /// allowed on an imported volume container
    /// </summary>
    public enum MigrationOperation
    {
        /// <summary>
        /// Represents a No operation
        /// </summary>
        Invalid = 0,
        
        /// <summary>
        /// Commit associated the volume container to the target device
        /// permanently
        /// </summary>
        Commit = 1,
        
        /// <summary>
        /// Rollback cleans-up the changes done by migration and reverts the
        /// volume container to a state prior to migration
        /// </summary>
        Rollback = 2,
    }
}
